;${PRODUCT_NAME} Installer
; Built with NSIS http://nsis.sourceforge.net/Main_Page

SetCompressor lzma

;Header Files
!include "MUI2.nsh"
!include "driver.nsh"

;Configuration
!define PRODUCT_NAME 'eZ430-RF2500-SEH Sensor Monitor'
!define PRODUCT_PUBLISHER 'Texas Instruments'
!define PRODUCT_VERSION 'v2.5'
!define MUI_ICON   "..\images\TI_Bug_Icon_Red.ico"
OutFile SEH-demo-setup-${PRODUCT_VERSION}.exe

InstallDir "$PROGRAMFILES\${PRODUCT_PUBLISHER}\${PRODUCT_NAME}"
InstallDirRegKey HKLM "Software\${PRODUCT_PUBLISHER}\${PRODUCT_NAME}" ""
RequestExecutionLevel admin

;MoreInfo plugin required to add file info: http://nsis.sourceforge.net/MoreInfo_plug-in
VIProductVersion "1.0.2.900"
VIAddVersionKey CompanyName "${PRODUCT_PUBLISHER}, Inc."
VIAddVersionKey FileVersion "${PRODUCT_VERSION}"
VIAddVersionKey ProductName "${PRODUCT_NAME}"
VIAddVersionKey FileDescription "${PRODUCT_NAME} Setup"
VIAddVersionKey LegalCopyright " 2009 ${PRODUCT_PUBLISHER}, Inc."
VIAddVersionKey LegalTrademarks "All Rights Reserved."

;Names
Name "${PRODUCT_NAME}"
Caption "${PRODUCT_NAME} ${PRODUCT_VERSION} Setup"

;Interface Settings
!define MUI_ABORTWARNING
;!define MUI_HEADERIMAGE
!define MUI_COMPONENTSPAGE_SMALLDESC
!define MUI_WELCOMEPAGE_TITLE_3LINES

;Pages
!define MUI_WELCOMEPAGE_TITLE "Welcome to the ${PRODUCT_NAME} ${PRODUCT_VERSION} Setup Wizard"
!define MUI_WELCOMEPAGE_TEXT "This will install ${PRODUCT_NAME} ${PRODUCT_VERSION} on your computer.$\r$\n$\r$\nIt is recommended that you close all other applicaitions before continuing. $\r$\n$\r$\n$_CLICK"

!insertmacro MUI_PAGE_WELCOME
;!insertmacro MUI_PAGE_COMPONENTS
!insertmacro MUI_PAGE_LICENSE "..\..\License.txt"
!insertmacro MUI_PAGE_DIRECTORY

Var StartMenuFolder
!define MUI_STARTMENUPAGE_DEFAULTFOLDER "${PRODUCT_PUBLISHER}\${PRODUCT_NAME}"
!insertmacro MUI_PAGE_STARTMENU "Application" $StartMenuFolder

!insertmacro MUI_PAGE_INSTFILES

!define MUI_FINISHPAGE_LINK "Visit the eZ430-RF2500-SEH site for the latest software."
!define MUI_FINISHPAGE_LINK_LOCATION "http://focus.ti.com/docs/toolsw/folders/print/ez430-rf2500-seh.html"

!define MUI_FINISHPAGE_RUN "$INSTDIR\sensMon.exe"
!define MUI_FINISHPAGE_NOREBOOTSUPPORT

!insertmacro MUI_PAGE_FINISH


; Uninstaller pages
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"

;Installer Sections
Section "eZ430-RF2500-SEH Core Files (required)" 
  SetDetailsPrint textonly
  DetailPrint "Installing eZ430-RF2500-SEH Core Files..."
  SetDetailsPrint listonly
	
  SectionIn RO	
	
  ; Set output path to the installation directory.
  SetOutPath $INSTDIR\drivers
	File ..\drivers\430cdc.cat
	File ..\drivers\430CDC.inf
	
	SetOutPath $INSTDIR\images
	File ..\images\accept.png
	File ..\images\Config.png
	File ..\images\Console.png
	File ..\images\copy.png
	File ..\images\Cymbet_Grey.png
	File ..\images\graph.png
	File ..\images\MSP430_Logo.png
	File ..\images\new.png
	File ..\images\open.png
	File ..\images\pause.png
	File ..\images\pdf.png
	File ..\images\play.png
	File ..\images\Readme.png
	File ..\images\save.png
	File ..\images\SEH_logo.png
	File ..\images\stop.png
	File ..\images\TI_Bug_Icon_Red.ico
	File ..\images\ti_logo_red.png
	File ..\images\TI_Red_Platform_Bar.png
	
	SetOutPath $INSTDIR
        File ..\sensMon.exe
	File ..\Microsoft.VC90.CRT.manifest
	File ..\msvcp90.dll
	File ..\msvcr90.dll
	File ..\QtCore4.dll
	File ..\QtGui4.dll
	File ..\qwt5.dll
	
	; Write the installation path into the registry
  WriteRegStr HKLM "SOFTWARE\\${PRODUCT_NAME}" "Install_Dir" "$INSTDIR"
  
  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}" "DisplayName" "${PRODUCT_NAME}  ${PRODUCT_VERSION}"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}" "NoRepair" 1
  WriteUninstaller "uninstall.exe"
SectionEnd

Section "Start Menu Shortcuts"
	CreateShortCut "$DESKTOP\eZ430-RF2500 SEH Sensor Monitor.lnk" "$INSTDIR\sensMon.exe"
        CreateDirectory "$SMPROGRAMS\${PRODUCT_PUBLISHER}\${PRODUCT_NAME}"
        CreateShortCut "$SMPROGRAMS\${PRODUCT_PUBLISHER}\${PRODUCT_NAME}\${PRODUCT_NAME}.lnk" "$INSTDIR\sensMon.exe"
	CreateShortCut "$SMPROGRAMS\${PRODUCT_PUBLISHER}\${PRODUCT_NAME}\Check for updates.lnk" "http://focus.ti.com/docs/toolsw/folders/print/ez430-rf2500-seh.html"
	CreateShortCut "$SMPROGRAMS\${PRODUCT_PUBLISHER}\${PRODUCT_NAME}\MSP430 Tools.lnk" "http://www.ti.com/msp430tools" 
	CreateShortCut "$SMPROGRAMS\${PRODUCT_PUBLISHER}\${PRODUCT_NAME}\Uninstall Sensor Monitor.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
SectionEnd


Section "Uninstall"  
  ;	 Remove registry keys
	DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
	DeleteRegKey HKLM "SOFTWARE\${PRODUCT_NAME}"

	; Remove files and uninstaller
	Delete $INSTDIR\sensMon.exe
	Delete $INSTDIR\slau273.pdf
	Delete $INSTDIR\uninstall.exe
	Delete $INSTDIR\sensMon.exe
	Delete $INSTDIR\slau273.pdf
	Delete $INSTDIR\Microsoft.VC90.CRT.manifest
	Delete $INSTDIR\msvcp90.dll
	Delete $INSTDIR\msvcr90.dll
	Delete $INSTDIR\QtCore4.dll
	Delete $INSTDIR\QtGui4.dll
	Delete $INSTDIR\qwt5.dll

	; Remove shortcuts, if any
	Delete "$SMPROGRAMS\${PRODUCT_PUBLISHER}\${PRODUCT_NAME}\*.*"

	; Remove directories used
	RMDir "$SMPROGRAMS\${PRODUCT_PUBLISHER}\${PRODUCT_NAME}"  
	RMDir /r $INSTDIR\dlls
	RMDir /r $INSTDIR\images
	RMDir /r $INSTDIR\drivers
	RMDir "$INSTDIR"
SectionEnd

Section "Install Drivers"
  Push "$INSTDIR\drivers" 		;  -- the directory of the .inf file
  Push "$INSTDIR\drivers\430CDC.inf" 	;  -- the filepath of the .inf file (directory + filename)
  Push "USB\Vid_0451&Pid_F432&MI_00"
  Call InstallUpgradeDriver
SectionEnd
	